/*! ********************************************
 * TonePresetFM.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth;
public class TonePresetFM
{
// Inastance -----
	public char[] toneName = {' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '}; // ASCII 16Chars 
	public int key			= 64;   // 0 - 127     *Percussion
	public int pan			= 64;   // 0 - 127     *Percussion
	public int lfoWave		= 0;    // 0 - 3
	public int lfoFreq		= 2048; // 0 - 16383   LFO - Phase Update Timer Parameter
	public int fl			= 127;  // 0 - 127     Feed Back Level
	public int strc			= 0;    // 0 - 7	    strcture
	// operator 0
	//public int velCurve_0;
	public int tlVelCtrl_0	= 0;   // 0 - 7        Total Level Contorol - Velocity   Senstivity
	public int mul_0		= 1;   // 0 - 7        Multiple       [0] = 1/2 Cycle, [1] = 1/1, [2] = 2/1, [3] = 3/1...
	public int tune_0		= 8192;// 0 - 16383    center 8192, octave = 8192
	public int lms_0		= 0;   // 0 - 15       LFO - Modulation Depth Senstivity
	public int wave_0		= 0;   // 0 - 7
	public int tl_0			= 0;   // 0 - 127
	public int ar_0			= 124; // 0 - 127
	public int dr_0			= 100; // 0 - 127
	public int sl_0			= 0;   // 0 - 127
	public int rr_0			= 120; // 0 - 127
	public int kf_0			= 0;   // 0 - 3        Key Follow Sensitivity         *Instrument 
	public int kfStart_0	= 48;  // 0 - 127      Key Number - Start Key Follow  *Instrument
	// operator 1
	//public int velCurve_1;
	public int tlVelCtrl_1	= 0;   // 0 - 7        Total Level Contorol - Velocity   Senstivity
	public int mul_1		= 1;   // 0 - 7        Multiple       [0] = 1/2 Cycle, [1] = 1/1, [2] = 2/1, [3] = 3/1...
	public int tune_1		= 8192;// 0 - 16383    center 8192, octave = 8192
	public int lms_1		= 0;   // 0 - 15       LFO - Modulation Depth Senstivity
	public int wave_1		= 0;   // 0 - 7
	public int tl_1			= 0;   // 0 - 127
	public int ar_1			= 124; // 0 - 127
	public int dr_1			= 100; // 0 - 127
	public int sl_1			= 0;   // 0 - 127
	public int rr_1			= 120; // 0 - 127
	public int kf_1			= 0;   // 0 - 3        Key Follow Sensitivity         *Instrument 
	public int kfStart_1	= 48;  // 0 - 127      Key Number - Start Key Follow  *Instrument
	
// Method
	public void copy(TonePresetFM preset)
	{
		for (int i = 0; i < 16; i++)toneName[i] = preset.toneName[i];
		key = preset.key;
		pan = preset.pan;
		lfoWave = preset.lfoWave;
		lfoFreq = preset.lfoFreq;		
		fl = preset.fl;
		strc = preset.strc;
		// operator 0
		tlVelCtrl_0	= preset.tlVelCtrl_0;
		mul_0		= preset.mul_0;
		tune_0		= preset.tune_0;
		lms_0		= preset.lms_0;
		wave_0		= preset.wave_0;
		tl_0		= preset.tl_0;
		ar_0		= preset.ar_0;
		dr_0		= preset.dr_0;
		sl_0		= preset.sl_0;
		rr_0		= preset.rr_0;
		kf_0		= preset.kf_0;
		kfStart_0	= preset.kfStart_0;
		// operator 1
		tlVelCtrl_1	= preset.tlVelCtrl_1;
		mul_1		= preset.mul_1;
		tune_1		= preset.tune_1;
		lms_1		= preset.lms_1;
		wave_1		= preset.wave_1;
		tl_1		= preset.tl_1;
		ar_1		= preset.ar_1;
		dr_1		= preset.dr_1;
		sl_1		= preset.sl_1;
		rr_1		= preset.rr_1;
		kf_1		= preset.kf_1;
		kfStart_1	= preset.kfStart_1;
	}
	public void reset()
	{
		for (int i = 0; i < 16; i++)toneName[i] = ' ';
		key = 64;
		pan = 64;
		lfoWave = 0;
		lfoFreq = 2048;
		fl = 127;
		strc = 0;
		// operator 0
		tlVelCtrl_0	= 0;
		mul_0		= 1;
		tune_0		= 8192;
		lms_0 		= 0;
		wave_0		= 0;
		tl_0		= 0;
		ar_0		= 124;
		dr_0		= 100;
		sl_0		= 0;
		rr_0		= 120;
		kf_0		= 0;
		kfStart_0	= 48;
		// operator 1
		tlVelCtrl_1	= 0;
		mul_1		= 1;
		tune_1		= 8192;
		lms_1 		= 0;
		wave_1		= 0;
		tl_1		= 0;
		ar_1		= 124;
		dr_1		= 100;
		sl_1		= 0;
		rr_1		= 120;
		kf_1		= 0;
		kfStart_1	= 48;
	}
// Constructor
	public TonePresetFM(){}
}